package com.rjconsultores.ventaboletos.dao.hibernate;

import java.util.List;

import org.hibernate.Criteria;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;

import com.rjconsultores.ventaboletos.dao.GP_PricingTipoServicioDAO;
import com.rjconsultores.ventaboletos.entidad.GP_Pricing;
import com.rjconsultores.ventaboletos.entidad.GP_PricingTipoServicio;
import com.rjconsultores.ventaboletos.entidad.TipoServicio;

@Repository("gp_pricingTipoServicioDAO")
public class GP_PricingTipoServicioHibernateDAO extends GenericHibernateDAO<GP_PricingTipoServicio, Integer>
		implements GP_PricingTipoServicioDAO {

	@Autowired
	public GP_PricingTipoServicioHibernateDAO(@Qualifier("sessionFactory") SessionFactory factory) {
		setSessionFactory(factory);
	}

	@Override
	public List<GP_PricingTipoServicio> obtenerTodos() {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq(ACTIVO, GP_Pricing.ATIVO));

		return c.list();
	}

	public Boolean obtenerPricingTipoServicio(GP_Pricing pricing, TipoServicio tipoServicio) {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq(ACTIVO, GP_Pricing.ATIVO));
		c.add(Restrictions.eq("pricing", pricing));
		c.add(Restrictions.eq("tipoServicio", tipoServicio));

		if (c.list().size() > 0) {
			return true;
		} else {
			return false;
		}
	}

	@Override
	public List<GP_PricingTipoServicio> obtenerTodoPorPricing(GP_Pricing pricing) {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq("pricing.pricingId", pricing.getPricingId()));

		return c.list();
	}
}
